declare module "upload-largest-files" {
    export enum HttpMethod {
        POST = "POST",
        GET = "GET",
        PUT = "PUT",
        PATCH = "PATCH"
    }
    interface UploadProps {
        file: File;
        url: string | URL;
        httpMethod?: HttpMethod;
        headers?: {
            [key: string]: string;
        };
        onProgress?: ((this: XMLHttpRequest, e: ProgressEvent) => void) | null;
    }
    export function uploadFile({ file, url, headers, httpMethod, onProgress, }: UploadProps): Promise<File>;
}
